<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardooliveira
 * Date: 12/05/14
 * Time: 13:17
 * To change this template use File | Settings | File Templates.
 */

namespace Financeiro\Logic\ContasReceber\Cnab\Retorno;
use Financeiro\Entities\Ajbolrec;
use Financeiro\Entities\Contareceber;
use Setforms2\Shared\ORM\DateTime;
use Financeiro\Entities\Cnabrec;
use Geral\Util\DateUtil;
use Setforms2\Shared\Registry;
use Financeiro\Entities\Baixarecebida;
use Geral\Util\Ambiente;
use Financeiro\Entities\Boletreceber;
use Financeiro\Entities\Errcnabbolr;
class OperacoesCnab {

    public static function insereRemessa($nrorg, $cdempresa, $nrcnabpag, $idtipcnabpag, DateTime $dtcnabpag , $cdoperador,
        $cdbanco,$dsArquivo){
        try
        {
            $cnabpag = new Cnabrec();
            $cnabpag->setNrorg($nrorg);
            $cnabpag->setCdempresa($cdempresa);
            $cnabpag->setNrcnabrec($nrcnabpag);
            $cnabpag->setDsarqcnabrec($dsArquivo);
            $cnabpag->setIdtipcnabrec($idtipcnabpag);
            $cnabpag->setDtcnabrec($dtcnabpag);
            $cnabpag->setCdoperador($cdoperador);
            $cnabpag->setCdbanco($cdbanco);
            $cnabpag->setDtinclusao(DateUtil::getDataAtual());

            $cnabpag->persist();
            Registry::getEntityManager()->flush();

            return $cnabpag;
        }catch(\Exception $e)
        {
            throw $e;
        }
    }

    public static function insereBaixa($cdempresa, $cdfilial, $cdtpbaixapag, DateTime $dtpagamento,
        $cdreducont, $cdoperador, $dtlancamento, $nrorg, $nrbaixapag, $vrbaixa,
        $nrcnabpag, $idstatuspag = Baixarecebida::STATUS_PENDENTE_CNAB ){

        try {
            $baixarece = new Baixarecebida();
            $baixarece->setNrbaixarec($nrbaixapag);
            $baixarece->setVrbaixarec($vrbaixa);
            $baixarece->setCdempresa($cdempresa);
            $baixarece->setCdfilial($cdfilial);
            $baixarece->setIdstatusbrec($idstatuspag);
            $baixarece->setCdtpbaixarec($cdtpbaixapag);
            $baixarece->setDtbaixarec($dtpagamento);
            $baixarece->setCdreducont($cdreducont);
            $baixarece->setCdoperador($cdoperador);
            $baixarece->setDtlancbaixar($dtlancamento);
            $baixarece->setNrorg($nrorg);
            $baixarece->setDsbaixarec("Baixa realizada via importação CNAB. Retorno nº {$nrcnabpag}");
            $baixarece->setDtinclusao(DateUtil::getDataAtual());
            $baixarece->setDtultatu(DateUtil::getDataAtual());
            $baixarece->setCdoperinclusao(Ambiente::getCdOperador());
            $baixarece->setCdoperultatu(Ambiente::getCdOperador());
            $baixarece->setIdativo('S');

            $baixarece->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insereValorBaixa($cdfilial, $nrbaixapag, $valor){

        try {
            /** @var $baixapaga Baixarecebida */
            $baixapaga = Baixarecebida::findOneByCdfilialAndNrbaixarec($cdfilial, $nrbaixapag);
            $baixapaga->setVrbaixarec($baixapaga->getVrbaixarec() + $valor);

            $baixapaga->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function alteraBoleto($cdfilial, $nrlanbolpag, $vrfinalbpag, $cdfilibaipag, $nrbaixapag,
        $nrcnabpagret, $idsitucnabp, $nrorg, $idstatrec = 'P'){

        try {
            /** @var $boletpagar Boletreceber */
            $boletpagar = Boletreceber::findOneByNrlanbolrecAndCdfilialAndNrorg($nrlanbolpag, $cdfilial, $nrorg);
            $boletpagar->setVrfinalbrec($vrfinalbpag);
            $boletpagar->setCdfilibairec($cdfilibaipag);
            $boletpagar->setNrbaixarec($nrbaixapag);
            $boletpagar->setNrcnabrecret($nrcnabpagret);
            $boletpagar->setIdsitucnabr($idsitucnabp);
            $boletpagar->setIdstatbrec($idstatrec);
            $boletpagar->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function deletaErroCnab($nrlanbolpag, $cdfilial, $nrorg){

        try{
            /** @var $errcnabbolr Errcnabbolr  */
            $errcnabbolrs = Errcnabbolr::findByNrlanbolrecAndCdfilialAndNrorg($nrlanbolpag, $cdfilial, $nrorg);
            foreach($errcnabbolrs as $errcnabbolr){
                $errcnabbolr->delete();
                $errcnabbolr->persist();
            }
            Registry::getEntityManager()->flush();
        }
        catch(\Exception $e){
            throw $e;
        }

    }

    public static function insereOcorencia($cdfilial, $nrlanbolpag, $cdbanco, $cdercnabbolp){

        try {
            $errcnabbolp = new Errcnabbolr();
            $errcnabbolp->setCdfilial($cdfilial);
            $errcnabbolp->setNrlanbolrec($nrlanbolpag);
            $errcnabbolp->setNrorg(Ambiente::getNrorg());
            $errcnabbolp->setCdbanco($cdbanco);
            $errcnabbolp->setCdercnabbolr($cdercnabbolp);
            $errcnabbolp->setDtinclusao(DateUtil::getDataAtual());
            $errcnabbolp->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;

        }
    }

    public static function insereAjuste($cdfilial, $nrlanbolrec, $cdajuctrec, $idorigajbrec, $vrajbolrec){
        try {
            $ajuste = Ajbolrec::findOneByNrorgAndCdfilialAndNrlanbolrecAndCdajuctrec(
                Ambiente::getNrorg(), $cdfilial, $nrlanbolrec, $cdajuctrec
            );
            if(!$ajuste){
                $ajuste = new Ajbolrec();
                $ajuste->setCdfilial($cdfilial);
                $ajuste->setNrlanbolrec($nrlanbolrec);
                $ajuste->setCdajuctrec($cdajuctrec);
                $ajuste->setIdorigajbrec($idorigajbrec);
                $ajuste->setVrajbolrec($vrajbolrec);
                $ajuste->setNrorg(Ambiente::getNrorg());
                $ajuste->setDtinclusao(DateUtil::getDataAtual(true));
                $ajuste->persist();
                Registry::getEntityManager()->flush();
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

}