function AlteracaoAprovacaoAfService(restEngine) {

    this.salvaValorTotalReal = function(currentRow) {
        return restEngine.post('\/cmp07600_autoforne_af\/save', {
            "requestType": "DataSet",
            "dataset": [
                currentRow
            ]
        });
    };

    this.verificaProdutoFornecedor = function(nrorg, cdFornecedor, cdProduto){
        return restEngine.post('\/verificaProdutoFornecedor', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDFORNECED": cdFornecedor,
                "CDPRODUTO": cdProduto
            }
        });
    };

    this.verificaQualificacaoMarca = function(nrorg, cdProduto, cdMarca, cdFilial, dtAutoForn){
        return restEngine.post('\/verificaQualificacaoMarca', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDMARCA": cdMarca,
                "CDFILIAL": cdFilial,
                "DTAUTOFORN": dtAutoForn
            }
        });
    };

    this.verificaProdQualificadoForn = function(nrorg, cdProduto, cdFornecedor, cdFilial, dtAutoForn){
        return restEngine.post('\/verificaProdQualificadoForn', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDFORNECED": cdFornecedor,
                "CDFILIAL": cdFilial,
                "DTAUTOFORN": dtAutoForn
            }
        });
    };

    this.verificaProdutoInativo = function(nrorg, cdProduto, cdFilial){
        return restEngine.post('\/verificaProdutoInativo', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDFILIAL": cdFilial
            }
        });
    };

    this.verificaPrazoPagamento = function(nrorg, cdFilDest, cdFilLanc, nrAutoForn){
        return restEngine.post('\/prazopgtaf', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "value": nrorg, "operator": "="},
                {"name": "CDFILDEST", "value": cdFilDest, "operator": "="},
                {"name": "CDFILLANC", "value": cdFilLanc, "operator": "="},
                {"name": "NRAUTOFORN", "value": nrAutoForn, "operator": "="}
            ]
        });
    };

    this.proceVerificaInconsAfs = function(paramProcedure){
        return restEngine.post('\/proceVerificaInconsAfs', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceImpostoItemAf = function(paramProcedure){
        return restEngine.post('\/proceImpostoItemAf', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceExcluiContaPagarPrevista = function(paramProcedure){
        return restEngine.post('\/proceExcluiContaPagarPrevista', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceGeraContaPagarPrevista = function(paramProcedure){
        return restEngine.post('\/proceGeraContaPagarPrevista', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceFechamentoAf = function(paramProcedure){
        return restEngine.post('\/proceFechamentoAf', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceConsisteOrcamento = function(paramProcedure){
        return restEngine.post('\/proceConsisteOrcamento', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('AlteracaoAprovacaoAfService', AlteracaoAprovacaoAfService);
});