function Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller(General, Utilities, RestEngine, ScreenService, templateManager){

    this.voltarAcomSoliCmp = function(widget) {
    	ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#cmp09500_acompanhamento_de_solicitacao_de_compras');
    };

     this.applyDefaultValue = function(widget) {
        widget.newRow();
        widget.currentRow.DT_ENTREGA = {
            start: moment().format('DD/MM/YYYY'),
            end: moment().format('DD/MM/YYYY'),
            formattedStart: moment().format('DD/MM/YYYY'),
            formattedEnd: moment().format('DD/MM/YYYY')
        };
        widget.currentRow.REPORT = 'SUP00704';
        if(widget.ABERTA_POR) {
	    	widget.getAction('voltar_acompanhamento_solicitacao_compras').isVisible = true;
		}
    };
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function setDatasParams(datas, defaultReturn = null) {
        return {
            "formattedStart": datas && datas.start ? datas.formattedStart : defaultReturn,
            "formattedEnd"  : datas && datas.end   ? datas.formattedEnd : defaultReturn
        };
    }
    
     this.dtSourceSolicitacao = function(widget) {
        
        const datas = setDatasParams(widget.currentRow.DT_ENTREGA);
        const solicitacao =  widget.getField('SOLICITACAO');
        
        solicitacao.dataSourceFilter = [
            {
                "name": "P_DTENTRINI",
                "operator": "=",
                "value": datas.formattedStart
            },
            {
                "name": "P_DTENTRFIN",
                "operator": "=",
                "value": datas.formattedEnd
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL !== "" ? concatArrayForParams(widget.currentRow.CDFILIAL) : 'T'
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        solicitacao.reload();
    };
    
    this.criaRelatorio = function(widget) {
        if (!widget.isValid()) return;
        
        const reportName = widget.currentRow.REPORT;
        
        General.openReportPopup(widget, abreRelatorio, [widget, widget.currentRow, reportName]);
    };
    
    function preencheCaracterDireita(string) {
        var pad = 'ZZZZZZZZZZZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);
    }
    
    function abreRelatorio(widget, row, reportName) {
        if(widget.isValid()) {
            row.DTINICIAL = row.DT_ENTREGA && row.DT_ENTREGA.start ? row.DT_ENTREGA.start : '';
            row.DTFINAL = row.DT_ENTREGA && row.DT_ENTREGA.end ? row.DT_ENTREGA.end : '';
            row.CDPRODFINAL = preencheCaracterDireita(row.CDPRODFIN);
            row.CDFILIAL = widget.currentRow.UNIDADE.length !== "" ? concatArrayForParams(widget.currentRow.UNIDADE) : 'T';
            row.CDFILIAL1 = row.CDFILIAL;
            row.NRSOLICMP = widget.currentRow.SOLICITACAO.length !== "" ? concatArrayForParams(widget.currentRow.SOLICITACAO) : 'T';
            General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/sup00700_relatorio', reportName, row);
        }
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller', Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller);
});    