function Cmp06600_LogDeSolicitacaoDeCompras_Controller(General, ScreenService, localStorageEngine, ZhFilterPreferences, Utilities) {
   
    this.setFilterInitValues = function(widget) {
	    const filterRow = {
            "CDFILIAL": getLocalVar('CDFILIAL'),
            "NMFILIALSOL": getLocalVar('NMFILIAL'),
            "PERIODO": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
	    };
	    
	    ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
 
    this.widgetOnEnter = function(widget) {
        widget.getField("NMFILIALSOL").filterProperties.readOnly = (window.projectCorp) ? false : true;
        
        const filterRow = {
    	    PERIODO : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    }     
    	   
        };
        
        Utilities.startFilter(widget, filterRow);
        //widget.getField("NMFILIALSOL").reload();
    	//this.setFilterInitValues(widget);
    };

    this.filtrar = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        
        if (typeof(filterRow) === 'object') {
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DATAINIC": filterRow.PERIODO.start,
                "P_DATAFINA": filterRow.PERIODO.end,
                "P_CDOPERADOR": !Util.isEmptyOrBlank(filterRow.NMOPERADOR) ? filterRow.NMOPERADOR.join('_') : 'T',
                "P_CDFILIAL": filterRow.CDFILIAL,
                "NRORG": filterRow.NRORG
            };
        }
    };
    
    this.setStripe = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const stripe = widget.container.getWidget('stripe');
        
    	stripe.getField('unidade').label = ScreenService.i18n('Unidade Solicitante: ') + filterRow.CDFILIAL + ' | ' + filterRow.NMFILIALSOL;
        stripe.getField('dataInicial').label = ScreenService.i18n('Data Inicial: ') + filterRow.PERIODO.start;
        stripe.getField('dataFinal').label = ScreenService.i18n('Data Final: ') + filterRow.PERIODO.end;
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06600_LogDeSolicitacaoDeCompras_Controller', Cmp06600_LogDeSolicitacaoDeCompras_Controller);
});